Module com.io7m.jregions.core
Package com.io7m.jregions.core.unparameterized.areas

## Class AreasD

- java.lang.Object
- - com.io7m.jregions.core.unparameterized.areas.AreasD

-     public final class AreasD
      extends java.lang.Object

  Functions over areas.

  These functions operate using the concepts of minimum-x, maximum-x, minimum-y, and maximum-y edges. It is up to individual applications to assign meaning to these edges such as "left" for minimum-x and "top" for minimum-y.

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static AreaD` | `alignCenter​(AreaD outer, AreaD inner)` | Align the area `inner` such that the center of the area is equal to the center of `outer`.
    `static AreaD` | `alignHorizontallyCenter​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnXCenter(AreaD, AreaD)`
    `static AreaD` | `alignHorizontallyMaxX​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnXMaxX(AreaD, AreaD)`
    `static AreaD` | `alignHorizontallyMaxXOffset​(AreaD outer, AreaD inner, double offset)` | Deprecated. Use `alignOnXMaxXOffset(AreaD, AreaD, double)`
    `static AreaD` | `alignHorizontallyMinX​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnXMinX(AreaD, AreaD)`
    `static AreaD` | `alignHorizontallyMinXOffset​(AreaD outer, AreaD inner, double offset)` | Deprecated. Use `alignOnXMinXOffset(AreaD, AreaD, double)`
    `static AreaD` | `alignMaxYMaxX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignMaxYMaxXOffset(AreaD, AreaD, double, double)` with zero offsets.
    `static AreaD` | `alignMaxYMaxXOffset​(AreaD outer, AreaD inner, double offset_x, double offset_y)` | Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static AreaD` | `alignMaxYMinX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignMaxYMinXOffset(AreaD, AreaD, double, double)` with zero offsets.
    `static AreaD` | `alignMaxYMinXOffset​(AreaD outer, AreaD inner, double offset_x, double offset_y)` | Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static AreaD` | `alignMinYMaxX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignMinYMaxXOffset(AreaD, AreaD, double, double)` with zero offsets.
    `static AreaD` | `alignMinYMaxXOffset​(AreaD outer, AreaD inner, double offset_x, double offset_y)` | Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static AreaD` | `alignMinYMinX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignMinYMinXOffset(AreaD, AreaD, double, double)` with zero offsets.
    `static AreaD` | `alignMinYMinXOffset​(AreaD outer, AreaD inner, double offset_x, double offset_y)` | Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static AreaD` | `alignOnXCenter​(AreaD outer, AreaD inner)` | Align the area `inner` along the X axis in the center of `outer`.
    `static AreaD` | `alignOnXMaxX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignOnXMaxXOffset(AreaD, AreaD, double)` with a zero offset.
    `static AreaD` | `alignOnXMaxXOffset​(AreaD outer, AreaD inner, double offset)` | Align the area `inner` along the X axis against the inside maximum-x edge of `outer`.
    `static AreaD` | `alignOnXMinX​(AreaD outer, AreaD inner)` | Equivalent to calling `alignOnXMinXOffset(AreaD, AreaD, double)` with a zero offset.
    `static AreaD` | `alignOnXMinXOffset​(AreaD outer, AreaD inner, double offset)` | Align the area `inner` along the X axis against the inside minimum-x edge of `outer`.
    `static AreaD` | `alignOnYCenter​(AreaD outer, AreaD inner)` | Align the area `inner` along the Y axis in the center of `outer`.
    `static AreaD` | `alignOnYMaxY​(AreaD outer, AreaD inner)` | Equivalent to calling `alignOnYMaxYOffset(AreaD, AreaD, double)` with a zero offset.
    `static AreaD` | `alignOnYMaxYOffset​(AreaD outer, AreaD inner, double offset)` | Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`.
    `static AreaD` | `alignOnYMinY​(AreaD outer, AreaD inner)` | Equivalent to calling `alignOnYMinYOffset(AreaD, AreaD, double)` with a zero offset.
    `static AreaD` | `alignOnYMinYOffset​(AreaD outer, AreaD inner, double offset)` | Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`.
    `static AreaD` | `alignVerticallyCenter​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnYCenter(AreaD, AreaD)`
    `static AreaD` | `alignVerticallyMaxY​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnYMaxY(AreaD, AreaD)`
    `static AreaD` | `alignVerticallyMaxYOffset​(AreaD outer, AreaD inner, double offset)` | Deprecated. Use `alignOnYMaxYOffset(AreaD, AreaD, double)`
    `static AreaD` | `alignVerticallyMinY​(AreaD outer, AreaD inner)` | Deprecated. Use `alignOnYMinY(AreaD, AreaD)`
    `static AreaD` | `alignVerticallyMinYOffset​(AreaD outer, AreaD inner, double offset)` | Deprecated. Use `alignOnYMinYOffset(AreaD, AreaD, double)`
    `static AreaD` | `containing​(AreaD a, AreaD b)` | Construct a area that will contain both `a` and `b`.
    `static boolean` | `contains​(AreaD a, AreaD b)` | Determine whether or not one area contains another.
    `static boolean` | `containsPoint​(AreaD a, double x, double y)` | Determine whether or not a area contains a given point.
    `static boolean` | `couldFitInside​(AreaD a, AreaD b)` | Determine whether or not one area could fit inside another.
    `static AreaD` | `create​(double x, double y, double size_x, double size_y)` | Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
    `static AreaD` | `fitBetweenHorizontal​(AreaD fit, AreaD a, AreaD b)` | Deprecated. Use `fitBetweenOnX(AreaD, AreaD, AreaD)`
    `static AreaD` | `fitBetweenOnX​(AreaD fit, AreaD a, AreaD b)` | Attempt to fit `fit` between `a` and `b`, horizontally.
    `static AreaD` | `fitBetweenOnY​(AreaD fit, AreaD a, AreaD b)` | Attempt to fit `fit` between `a` and `b`, vertically.
    `static AreaD` | `fitBetweenVertical​(AreaD fit, AreaD a, AreaD b)` | Deprecated. Use `fitBetweenOnY(AreaD, AreaD, AreaD)`
    `static AreaD` | `hollowOut​(AreaD outer, double min_x_offset, double max_x_offset, double min_y_offset, double max_y_offset)` | Construct a new area that fits inside `outer` based on the given offsets from each edge.
    `static AreaD` | `hollowOutEvenly​(AreaD outer, double offset)` | Equivalent to calling `hollowOut(AreaD, double, double, double, double)` with `offset` for all offset parameters.
    `static AreaD` | `moveAbsolute​(AreaD area, double x, double y)` | Move the given area to `(x, y)`.
    `static AreaD` | `moveRelative​(AreaD area, double x, double y)` | Move the given area by `(x, y)`.
    `static AreaD` | `moveToOrigin​(AreaD area)` | Move the given area to `(0, 0)`.
    `static boolean` | `overlaps​(AreaD a, AreaD b)` | Determine whether or not two areas overlap.
    `static AreaD` | `scaleFromCenter​(AreaD area, double x_diff, double y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaD` | `scaleFromMaxYMaxX​(AreaD area, double x_diff, double y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaD` | `scaleFromMaxYMinX​(AreaD area, double x_diff, double y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaD` | `scaleFromMinYMaxX​(AreaD area, double x_diff, double y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaD` | `scaleFromMinYMinX​(AreaD area, double x_diff, double y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaD` | `setSizeFromCenter​(AreaD area, double sizeX, double sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaD` | `setSizeFromMaxYMaxX​(AreaD area, double sizeX, double sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaD` | `setSizeFromMaxYMinX​(AreaD area, double sizeX, double sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaD` | `setSizeFromMinYMaxX​(AreaD area, double sizeX, double sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaD` | `setSizeFromMinYMinX​(AreaD area, double sizeX, double sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static java.lang.String` | `show​(AreaD area)` |
    `static java.lang.String` | `showToBuilder​(AreaD area, java.lang.StringBuilder sb)` |
    `static AreaSizeD` | `size​(AreaD area)` |
    `static AreaXSplitD<AreaD>` | `splitAlongParallelToX​(AreaD area, double y)` | Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
    `static AreaYSplitD<AreaD>` | `splitAlongParallelToY​(AreaD area, double x)` | Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
    `static AreaXYSplitD<AreaD>` | `splitAlongXY​(AreaD area, double x, double y)` | Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static AreaD create​(double x,
                                     double y,
                                     double size_x,
                                     double size_y)

      Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
      Parameters:
        `x` - The X value of the minimum corner
        `y` - The Y value of the minimum corner
        `size_x` - The size of the area on the X axis
        `size_y` - The size of the area on the Y axis
      Returns:
        An area

    - #### contains

          public static boolean contains​(AreaD a,
                                         AreaD b)

      Determine whether or not one area contains another.

      Containing is reflexive: `contains(a, a) == true`.

      Containing is transitive: `contains(a, b) \u2192 contains(b, c) \u2192 contains(a, c)`.

      Containing is not necessarily symmetric.

      Parameters:
        `a` - Area A
        `b` - Area B
      Returns:
        `true` iff `a` contains `b`

    - #### moveRelative

          public static AreaD moveRelative​(AreaD area,
                                           double x,
                                           double y)

      Move the given area by `(x, y)`.
      Parameters:
        `area` - The area
        `x` - The amount to move on the X axis
        `y` - The amount to move on the Y axis
      Returns:
        A moved area

    - #### moveAbsolute

          public static AreaD moveAbsolute​(AreaD area,
                                           double x,
                                           double y)

      Move the given area to `(x, y)`.
      Parameters:
        `area` - The area
        `x` - The position to which to move on the X axis
        `y` - The position to which to move on the Y axis
      Returns:
        A moved area

    - #### moveToOrigin

          public static AreaD moveToOrigin​(AreaD area)

      Move the given area to `(0, 0)`.
      Parameters:
        `area` - The area
      Returns:
        A moved area

    - #### alignOnXCenter

          public static AreaD alignOnXCenter​(AreaD outer,
                                             AreaD inner)

      Align the area `inner` along the X axis in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinX

          public static AreaD alignOnXMinX​(AreaD outer,
                                           AreaD inner)

      Equivalent to calling `alignOnXMinXOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinXOffset

          public static AreaD alignOnXMinXOffset​(AreaD outer,
                                                 AreaD inner,
                                                 double offset)

      Align the area `inner` along the X axis against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxX

          public static AreaD alignOnXMaxX​(AreaD outer,
                                           AreaD inner)

      Equivalent to calling `alignOnXMaxXOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxXOffset

          public static AreaD alignOnXMaxXOffset​(AreaD outer,
                                                 AreaD inner,
                                                 double offset)

      Align the area `inner` along the X axis against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinY

          public static AreaD alignOnYMinY​(AreaD outer,
                                           AreaD inner)

      Equivalent to calling `alignOnYMinYOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinYOffset

          public static AreaD alignOnYMinYOffset​(AreaD outer,
                                                 AreaD inner,
                                                 double offset)

      Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxY

          public static AreaD alignOnYMaxY​(AreaD outer,
                                           AreaD inner)

      Equivalent to calling `alignOnYMaxYOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxYOffset

          public static AreaD alignOnYMaxYOffset​(AreaD outer,
                                                 AreaD inner,
                                                 double offset)

      Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYCenter

          public static AreaD alignOnYCenter​(AreaD outer,
                                             AreaD inner)

      Align the area `inner` along the Y axis in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignHorizontallyCenter

          @Deprecated
          public static AreaD alignHorizontallyCenter​(AreaD outer,
                                                      AreaD inner)

      Deprecated. Use `alignOnXCenter(AreaD, AreaD)`
      Align the area `inner` horizontally in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinX

          @Deprecated
          public static AreaD alignHorizontallyMinX​(AreaD outer,
                                                    AreaD inner)

      Deprecated. Use `alignOnXMinX(AreaD, AreaD)`
      Equivalent to calling `alignHorizontallyMinXOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinXOffset

          @Deprecated
          public static AreaD alignHorizontallyMinXOffset​(AreaD outer,
                                                          AreaD inner,
                                                          double offset)

      Deprecated. Use `alignOnXMinXOffset(AreaD, AreaD, double)`
      Align the area `inner` horizontally against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignHorizontallyMaxX

          @Deprecated
          public static AreaD alignHorizontallyMaxX​(AreaD outer,
                                                    AreaD inner)

      Deprecated. Use `alignOnXMaxX(AreaD, AreaD)`
      Equivalent to calling `alignHorizontallyMaxXOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMaxXOffset

          @Deprecated
          public static AreaD alignHorizontallyMaxXOffset​(AreaD outer,
                                                          AreaD inner,
                                                          double offset)

      Deprecated. Use `alignOnXMaxXOffset(AreaD, AreaD, double)`
      Align the area `inner` horizontally against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMinY

          @Deprecated
          public static AreaD alignVerticallyMinY​(AreaD outer,
                                                  AreaD inner)

      Deprecated. Use `alignOnYMinY(AreaD, AreaD)`
      Equivalent to calling `alignVerticallyMinYOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMinYOffset

          @Deprecated
          public static AreaD alignVerticallyMinYOffset​(AreaD outer,
                                                        AreaD inner,
                                                        double offset)

      Deprecated. Use `alignOnYMinYOffset(AreaD, AreaD, double)`
      Align the area `inner` vertically against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMaxY

          @Deprecated
          public static AreaD alignVerticallyMaxY​(AreaD outer,
                                                  AreaD inner)

      Deprecated. Use `alignOnYMaxY(AreaD, AreaD)`
      Equivalent to calling `alignVerticallyMaxYOffset(AreaD, AreaD, double)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMaxYOffset

          @Deprecated
          public static AreaD alignVerticallyMaxYOffset​(AreaD outer,
                                                        AreaD inner,
                                                        double offset)

      Deprecated. Use `alignOnYMaxYOffset(AreaD, AreaD, double)`
      Align the area `inner` vertically against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyCenter

          @Deprecated
          public static AreaD alignVerticallyCenter​(AreaD outer,
                                                    AreaD inner)

      Deprecated. Use `alignOnYCenter(AreaD, AreaD)`
      Align the area `inner` vertically in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinX

          public static AreaD alignMinYMinX​(AreaD outer,
                                            AreaD inner)

      Equivalent to calling `alignMinYMinXOffset(AreaD, AreaD, double, double)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinXOffset

          public static AreaD alignMinYMinXOffset​(AreaD outer,
                                                  AreaD inner,
                                                  double offset_x,
                                                  double offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMinYMaxX

          public static AreaD alignMinYMaxX​(AreaD outer,
                                            AreaD inner)

      Equivalent to calling `alignMinYMaxXOffset(AreaD, AreaD, double, double)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMaxXOffset

          public static AreaD alignMinYMaxXOffset​(AreaD outer,
                                                  AreaD inner,
                                                  double offset_x,
                                                  double offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMinX

          public static AreaD alignMaxYMinX​(AreaD outer,
                                            AreaD inner)

      Equivalent to calling `alignMaxYMinXOffset(AreaD, AreaD, double, double)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMinXOffset

          public static AreaD alignMaxYMinXOffset​(AreaD outer,
                                                  AreaD inner,
                                                  double offset_x,
                                                  double offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMaxX

          public static AreaD alignMaxYMaxX​(AreaD outer,
                                            AreaD inner)

      Equivalent to calling `alignMaxYMaxXOffset(AreaD, AreaD, double, double)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMaxXOffset

          public static AreaD alignMaxYMaxXOffset​(AreaD outer,
                                                  AreaD inner,
                                                  double offset_x,
                                                  double offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignCenter

          public static AreaD alignCenter​(AreaD outer,
                                          AreaD inner)

      Align the area `inner` such that the center of the area is equal to the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### hollowOut

          public static AreaD hollowOut​(AreaD outer,
                                        double min_x_offset,
                                        double max_x_offset,
                                        double min_y_offset,
                                        double max_y_offset)

      Construct a new area that fits inside `outer` based on the given offsets from each edge.
      Parameters:
        `outer` - The containing area
        `min_x_offset` - The offset from the minimum-x edge (must be non-negative)
        `max_x_offset` - The offset from the maximum-x edge (must be non-negative)
        `min_y_offset` - The offset from the minimum-y edge (must be non-negative)
        `max_y_offset` - The offset from the maximum-y edge (must be non-negative)
      Returns:
        A new area

    - #### hollowOutEvenly

          public static AreaD hollowOutEvenly​(AreaD outer,
                                              double offset)

      Equivalent to calling `hollowOut(AreaD, double, double, double, double)` with `offset` for all offset parameters.
      Parameters:
        `outer` - The containing area
        `offset` - The offset from each edge (must be non-negative)
      Returns:
        A new area

    - #### setSizeFromCenter

          public static AreaD setSizeFromCenter​(AreaD area,
                                                double sizeX,
                                                double sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized from its own center.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMinX

          public static AreaD setSizeFromMinYMinX​(AreaD area,
                                                  double sizeX,
                                                  double sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMaxX

          public static AreaD setSizeFromMinYMaxX​(AreaD area,
                                                  double sizeX,
                                                  double sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMaxX

          public static AreaD setSizeFromMaxYMaxX​(AreaD area,
                                                  double sizeX,
                                                  double sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMinX

          public static AreaD setSizeFromMaxYMinX​(AreaD area,
                                                  double sizeX,
                                                  double sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### scaleFromMinYMinX

          public static AreaD scaleFromMinYMinX​(AreaD area,
                                                double x_diff,
                                                double y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMinYMaxX

          public static AreaD scaleFromMinYMaxX​(AreaD area,
                                                double x_diff,
                                                double y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMinX

          public static AreaD scaleFromMaxYMinX​(AreaD area,
                                                double x_diff,
                                                double y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMaxX

          public static AreaD scaleFromMaxYMaxX​(AreaD area,
                                                double x_diff,
                                                double y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromCenter

          public static AreaD scaleFromCenter​(AreaD area,
                                              double x_diff,
                                              double y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized from its own center.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### overlaps

          public static boolean overlaps​(AreaD a,
                                         AreaD b)

      Determine whether or not two areas overlap.

      Overlapping is reflexive: `overlaps(a, a) == true`.

      Overlapping is symmetric: `overlaps(a, b) == overlaps(b, a)`.

      Overlapping is not necessarily transitive.

      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` overlaps `b`

    - #### couldFitInside

          public static boolean couldFitInside​(AreaD a,
                                               AreaD b)

      Determine whether or not one area could fit inside another.

      Fitting is reflexive: `couldFitInside(a, a) == true`.

      Fitting is transitive: `couldFitInside(a, b) \u2192 couldFitInside(b, c) \u2192 couldFitInside(a, c)`.

      Fitting is not necessarily symmetric.

      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` could fit inside `b`

    - #### containing

          public static AreaD containing​(AreaD a,
                                         AreaD b)

      Construct a area that will contain both `a` and `b`.
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        An area containing `a` and `b`

    - #### containsPoint

          public static boolean containsPoint​(AreaD a,
                                              double x,
                                              double y)

      Determine whether or not a area contains a given point.

      Parameters:
        `a` - An area
        `x` - The X coordinate of the point
        `y` - The Y coordinate of the point
      Returns:
        `true` iff `a` contains `(x, y)`

    - #### fitBetweenHorizontal

          @Deprecated
          public static AreaD fitBetweenHorizontal​(AreaD fit,
                                                   AreaD a,
                                                   AreaD b)

      Deprecated. Use `fitBetweenOnX(AreaD, AreaD, AreaD)`
      Attempt to fit `fit` between `a` and `b`, horizontally.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenVertical

          @Deprecated
          public static AreaD fitBetweenVertical​(AreaD fit,
                                                 AreaD a,
                                                 AreaD b)

      Deprecated. Use `fitBetweenOnY(AreaD, AreaD, AreaD)`
      Attempt to fit `fit` between `a` and `b`, vertically.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnX

          public static AreaD fitBetweenOnX​(AreaD fit,
                                            AreaD a,
                                            AreaD b)

      Attempt to fit `fit` between `a` and `b`, horizontally.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnY

          public static AreaD fitBetweenOnY​(AreaD fit,
                                            AreaD a,
                                            AreaD b)

      Attempt to fit `fit` between `a` and `b`, vertically.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### splitAlongParallelToX

          public static AreaXSplitD<AreaD> splitAlongParallelToX​(AreaD area,
                                                                 double y)

      Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
      Parameters:
        `area` - The area to be split
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongParallelToY

          public static AreaYSplitD<AreaD> splitAlongParallelToY​(AreaD area,
                                                                 double x)

      Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongXY

          public static AreaXYSplitD<AreaD> splitAlongXY​(AreaD area,
                                                         double x,
                                                         double y)

      Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        The four resulting quadrants
      Since:
        1.1.0

    - #### show

          public static java.lang.String show​(AreaD area)

      Parameters:
        `area` - The area
      Returns:
        A terse string describing the position and size of the area

    - #### size

          public static AreaSizeD size​(AreaD area)

      Parameters:
        `area` - The area
      Returns:
        The size of the area

    - #### showToBuilder

          public static java.lang.String showToBuilder​(AreaD area,
                                                       java.lang.StringBuilder sb)

      Parameters:
        `area` - The area
        `sb` - A string builder
      Returns:
        A terse string describing the position and size of the area

Copyright © 2017 <code@io7m.com> http://io7m.com